// Cambits
// Bucket main
//  Copyright (c) 2016, Columbia University
//  All rights reserved.
//
//                                /|\  /|\
//               MSP430F5510      10k  10k     MSP430F5510
//                   master         |    |        slave
//             -----------------   |    |   -----------------
//           -|XIN  P3.0/UCB0SDA|<-|----+->|P4.1/UCB1SDA  XIN|-
//            |                 |  |       |                 | 32kHz
//           -|XOUT             |  |       |             XOUT|-
//            |     P3.1/UCB0SCL|<-+------>|P4.2/UCB1SCL     |
//            |                 |          |             P1.0|--> LED
// 06/24/2015 Comfirmed 1st board
// 09/28/2015 Comfirmed 2nd board
//******************************************************************************

// Define
/// DEV_BOARD_F5510_1 First development board
///                          P1[7:0] LED
///                          P2[3:0] DIP SW for ID
/// DEV_BOARD_F5510_2 Second development board
///                          P1[1:0] LED
///                          The DIP SW for ID does not exist
/// EVA_BOARD_F5529   EVA board F5529

#include <msp430.h>
#include "bucket.h"
#include "i2c_com.h"
#include "i2c_test.h"
#include "servo.h"
#include "focal_stack.h"

void initilize_port();
extern unsigned char servo_flag;

volatile long read_cnt;
volatile long up_cnt;
void main(void)
{
	//   Stop WDT
 	WDTCTL = WDTPW + WDTHOLD;
	initilize_port();
	read_cnt=0;
	up_cnt=0;
	servo_flag=0;

	servo_initialize();
//	set_pwm(90);



	while (1)
	{

		// Read bucket data via i2c
		bucket_main();


////////// Test
		// Read
		//		i2c_master_rx_test();
		//		i2c_master_rx_test_i2c_exp();
		//  	i2c_slave_tx_test();
		// Write
		//		i2c_master_tx_test();
		//		i2c_slave_rx_test();
//		i2c_write_long_test();

		// Linear actuator
		//linear_actuator_reciprocating_test();
		//linear_actuator_debug_via_com();

		// Servo test
		//servo_test();
		//i2c_led_driver_test();


	}

}


void initilize_port()
{

#ifdef EVA_BOARD_F5529
	// Initialize for General Port
	//   Set port directions
	P1DIR |= BIT0;

	// Checking status of current MCU // TEMPORARY SETTING FOR EVA BOARD
	//  2.2 type[0]
	//  2.3 type[1]
	//  2.4 sub-type[0]
	//  2.5 sub-type[1]
	P2DIR =0x0;
	P4DIR |= BIT7;
#endif

#ifdef DEV_BOARD_F5510_1
	// Setting port for F5510
	P1DIR |= 0xFF;	// Set P1.0 to output direction
//	P2DIR =  0x00;	// Set P2.0 to input direction
//	P2REN |=  0x0F;	// enable internal pullup/pulldown
//	P2OUT |=  0x0F; // pull up selected
	initialize_timer();

#endif

#ifdef DEV_BOARD_F5510_2
	// Setting port for F5510
	P1DIR |= 0xFF;	// Set P1.0 to output direction

	P2DIR |= BIT0+BIT1;        // P2.0(PWM-servo) and P2.1 to output
	P2SEL |= BIT0;             // P2.0 to TA0.1
//	P2OUT |=  0x00; // pull up selected
#endif

	// Set P1.0 to output direction

	  // FOR USCI_B0
	  P3SEL |= BIT1 | BIT0;                            // Assign I2C pins to USCI_B0
#ifdef __PULLUP_INSIDE
	  P3REN |= BIT1 | BIT0;
	  P3OUT |= BIT1 | BIT0;
#endif

	  // FOR USCI_B1
	  P4SEL |= BIT2 | BIT1;                            // Assign I2C pins to USCI_B1
#ifdef __PULLUP_INSIDE
	  P4REN |= BIT2 | BIT1;
	  P4OUT |= BIT2 | BIT1;
#endif

	  return;
}

