/*
 * servo.h
 *
 *  Created on: Sep 18, 2015
 *      Author: makoto
 */

#ifndef SERVO_H_
#define SERVO_H_

void control_servo(unsigned char servo_flag);
void servo_initialize();
void set_pwm(int);
int get_servo_step_degree(int ,int ,int );
void move_servo(int );
void servo_test();


#define XT1_CLK 32768 // 32.768kHz
#define XT1_CYCLE 31  //  30.52[usec]

#define XT2_CLK 10593 // 10593 count
#define XT2_CYCLE 1.0593  //  1.059 MHz

#define XT1_PWM 328
#define XT2_PWM 10593

// SPEC FOR HS5035HD
#define HS5035HD_MIN_DUTY 1000
#define HS5035HD_MAX_DUTY 2000
#define HS5035HD_NEUTRAL_DUTY 1500
#define HS5035HD_ZERO_DUTY 1000
#define HS5035HD_MIN_DEGREE -90
#define HS5035HD_MAX_DEGREE 90
#define HS5035HD_SPEED_RATIO (HS5035HD_MAX_DUTY-HS5035HD_NEUTRAL_DUTY)/HS5035HD_MAX_DEGREE


#define PWM_PERIOD 10*1000  // 10msec

// SETTING FOR THIS FUNCTION
#define MIN_DUTY HS5035HD_MIN_DUTY
#define MAX_DUTY HS5035HD_MAX_DUTY
#define MIN_DEGREE HS5035HD_MIN_DEGREE
#define MAX_DEGREE HS5035HD_MAX_DEGREE
#define DEGREE_SPEED_RATIO HS5035HD_SPEED_RATIO
#define NUETRAL_DUTY HS5035HD_NEUTRAL_DUTY

// need to calicurate
#define DEGREE_STEP 4
#define SERVO_DELAY 666




#endif /* SERVO_H_ */
